package com.winhc.max.compute.graph.job.enterprise_group;

import com.aliyun.odps.graph.Aggregator;
import com.aliyun.odps.graph.WorkerContext;
import com.aliyun.odps.io.BooleanWritable;
import com.aliyun.odps.io.NullWritable;
import com.winhc.max.compute.graph.job.enterprise_group.entity.EnterpriseGroupAggValue;

import java.io.IOException;

/**
 * @author: XuJiakai
 * 2023/2/7 14:16
 */
public class EnterpriseGroupAggregator extends Aggregator<EnterpriseGroupAggValue> {
    @Override
    public EnterpriseGroupAggValue createInitialValue(WorkerContext context) throws IOException {
        return new EnterpriseGroupAggValue();
    }

    @Override
    public void aggregate(EnterpriseGroupAggValue enterpriseGroupAggValue, Object item) throws IOException {
        if (item instanceof NullWritable) {
            enterpriseGroupAggValue.increment();
        } else {
            BooleanWritable tmp = ((BooleanWritable) item);
            enterpriseGroupAggValue.update(tmp.get());
        }
    }

    @Override
    public void merge(EnterpriseGroupAggValue enterpriseGroupAggValue, EnterpriseGroupAggValue partial) throws IOException {
        boolean tmp = partial.getFlag().get();
        enterpriseGroupAggValue.update(tmp);
        enterpriseGroupAggValue.increment(partial.getCount());
    }

    @Override
    public boolean terminate(WorkerContext context, EnterpriseGroupAggValue enterpriseGroupAggValue) throws IOException {
        System.out.println("step: " + context.getSuperstep() + ", 本轮迭代节点数：" + enterpriseGroupAggValue.getCount() + " ,flag=" + enterpriseGroupAggValue.getFlag().get());
        return !enterpriseGroupAggValue.getFlag().get();
    }
}
