package com.winhc.max.compute.graph.job.enterprise_group.entity;

import com.aliyun.odps.io.BooleanWritable;
import com.aliyun.odps.io.LongWritable;
import com.aliyun.odps.io.Writable;

import java.io.DataInput;
import java.io.DataOutput;
import java.io.IOException;

/**
 * @author: XuJiakai
 * 2023/2/7 14:11
 */
public class EnterpriseGroupAggValue implements Writable {

    /**
     * 为false时表示迭代完毕，可以结束
     */
    private BooleanWritable flag;

    /**
     * 本轮迭代顶点数
     */
    private LongWritable num;

    public BooleanWritable getFlag() {
        return flag;
    }

    public long getCount(){
        return this.num.get();
    }

    public void increment() {
        increment(1);
    }

    public void increment(long num) {
        this.num.set(this.num.get() + num);
    }

    public void update(boolean flag) {
        this.flag.set(this.flag.get() || flag);
    }


    public EnterpriseGroupAggValue() {
        flag = new BooleanWritable(false);
        this.num = new LongWritable(0);
    }

    @Override
    public void write(DataOutput out) throws IOException {
        flag.write(out);
        num.write(out);
    }

    @Override
    public void readFields(DataInput in) throws IOException {
        BooleanWritable booleanWritable = new BooleanWritable();
        LongWritable num = new LongWritable();
        booleanWritable.readFields(in);
        num.readFields(in);
    }
}
