package com.winhc.max.compute.graph.job.pagerank;

import com.aliyun.odps.io.DoubleWritable;
import com.aliyun.odps.io.LongWritable;
import com.aliyun.odps.io.Writable;

import java.io.DataInput;
import java.io.DataOutput;
import java.io.IOException;

/**
 * @author: XuJiakai
 * 2022/6/7 15:41
 */
public class PageRankAggValue implements Writable {

    public PageRankAggValue() {
        n = new LongWritable(0);
        sumValue = new DoubleWritable(0);
    }

    private LongWritable n;
    private DoubleWritable sumValue;

    /**
     * @param value (newPr -oldPr)^2
     */
    public void addNewValue(double value) {
        update(n.get() + 1, sumValue.get() + value);
    }

    public void update(long n, double sumValue) {
        this.sumValue = new DoubleWritable(sumValue);
        this.n = new LongWritable(n);
    }

    public LongWritable getN() {
        return n;
    }

    public DoubleWritable getSumValue() {
        return sumValue;
    }

    @Override
    public void write(DataOutput out) throws IOException {
        n.write(out);
        sumValue.write(out);
    }

    @Override
    public void readFields(DataInput in) throws IOException {
        n = new LongWritable();
        sumValue = new DoubleWritable();
        n.readFields(in);
        sumValue.readFields(in);
    }
}
